// MYHOOKIMPL.H : Declaration of the TMyHookImpl

#ifndef MyHookImplH
#define MyHookImplH

#define ATL_APARTMENT_THREADED

#include "CopyHook_TLB.H"


/////////////////////////////////////////////////////////////////////////////
// TMyHookImpl     Implements IMyHook, default interface of MyHook
// ThreadingModel : Apartment
// Dual Interface : FALSE
// Event Support  : FALSE
// Default ProgID : CopyHook.MyHook
// Description    : 
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TMyHookImpl : 
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TMyHookImpl, &CLSID_MyHook>,
  public ICopyHook,
  DUALINTERFACE_IMPL(MyHook, IMyHook) //public IMyHook
{
public:
  TMyHookImpl()
  {
  }

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("CopyHook.MyHook");
  DECLARE_DESCRIPTION("");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TMyHookImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }

  STDMETHODIMP_(UINT) CopyCallback (HWND hwnd, UINT wFunc, UINT wFlags, LPCSTR pszSrcFile, DWORD dwSrcAttribs,LPCSTR pszDestFile, DWORD dwDestAttribs);

BEGIN_COM_MAP(TMyHookImpl)
  COM_INTERFACE_ENTRY(ICopyHook)  //COM_INTERFACE_ENTRY(IMyCopyHook)
  COM_INTERFACE_ENTRY_IID(IID_IShellCopyHook , TMyHookImpl)
  DUALINTERFACE_ENTRY(IMyHook)
END_COM_MAP()

// IMyHook
public:

};

#endif //MyHookImplH
